#include "DxPixelShaderFxCode2.h"

// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 TextureDiffuseColor ;
	float4 TextureSpecularColor ;
	float4 ToonSpecularGradColor ;
	float4 ToonDiffuseGradColor ;
	float4 ToonSphereMapColor ;
	float4 ToonRGBtoVMaxRGBVolumeColor ;
	
	float DiffuseAngleGen ;
	float4 TotalDiffuse ;
	float4 TotalSpecular ;
	float4 TotalLightDiffuse ;
	float3 TotalAmbient ;
	float TotalAngleGen ;
	float Temp ;
	float3 TempF3 ;
	float4 TempF4 ;
	float3 Normal ;
	float3 V_to_Eye ;
	float3 VNrm ;
	float3 VTan ;
	float3 VBin ;
	float3 lLightTemp ;
	float lLightDistancePow2 ;
	float lLightGen ;
	float3 lLightDir ;
	float lLightDirectionCosA ;
	float3 ShadowRate ;
	float ShadowGen ;

#if SHADOWMAP
	float2 DepthTexCoord ;
	float4 TextureDepth ;
//	float4 variance_md_p_pmax ;
#endif
	
#if SUBTEXTUREMODE != 0
	float4 SubTextureColor;
#endif  // SUBTEXTUREMODE != 0

	// ڐE]@E@𐳋K
	VNrm = normalize( PSInput.VNormal ) ;
#ifdef BUMPMAP
	VTan = normalize( PSInput.VTan ) ;
	VBin = normalize( PSInput.VBin ) ;
#endif // BUMPMAP

#ifdef BUMPMAP
	// _W王_ւ̃xNgڒԂɓe㐳Kĕۑ
	TempF3.x = dot( VTan, -PSInput.VPosition.xyz ) ;
	TempF3.y = dot( VBin, -PSInput.VPosition.xyz ) ;
	TempF3.z = dot( VNrm, -PSInput.VPosition.xyz ) ;
	V_to_Eye = normalize( TempF3 ) ;
#else // BUMPMAP
	// _W王_ւ̃xNg𐳋K
	V_to_Eye = normalize( -PSInput.VPosition ) ;
#endif // BUMPMAP

	// @̏
	#if BUMPMAP
		// @ 0`1 ̒l -1.0`1.0 ɕϊ
		Normal = ( tex2D( NormalMapTexture, PSInput.TexCoords0_1.xy ).rgb - cfZeroHalfOneTwo.y ) * cfZeroHalfOneTwo.w ;
	#else // BUMPMAP
		Normal = normalize( PSInput.VNormal ) ;
	#endif // BUMPMAP

	// fBt[YeNX`J[擾
	TextureDiffuseColor = tex2D( DiffuseMapTexture, PSInput.TexCoords0_1.xy ) ;
	
#ifdef USE_SPE
	#ifdef USE_SPETEX
	// fXyLeNX`J[擾
	TextureSpecularColor = tex2D( SpecularMapTexture, PSInput.TexCoords0_1.xy ) ;
	#endif // USE_SPETEX
#endif // USE_SPE

#if SUBTEXTUREMODE != 0
	// TueNX`J[擾
	SubTextureColor = tex2D( SubTexture, PSInput.TexCoords0_1.zw );
#endif  // SUBTEXTUREMODE != 0

	// TueNX`J[ƃfBt[YeNX`J[̊|킹
#if SUBTEXTUREMODE == 1  // uh( MV1_LAYERBLEND_TYPE_TRANSLUCENT + 1 )
	TextureDiffuseColor.rgb = lerp( TextureDiffuseColor.rgb, SubTextureColor.rgb, SubTextureColor.a );
#endif // SUBTEXTUREMODE == 1

#if SUBTEXTUREMODE == 2  // Z( MV1_LAYERBLEND_TYPE_ADDITIVE + 1 )
	TextureDiffuseColor.rgb += SubTextureColor.rgb;
#endif // SUBTEXTUREMODE == 2

#if SUBTEXTUREMODE == 3  // Z( MV1_LAYERBLEND_TYPE_MODULATE + 1 )
	TextureDiffuseColor.rgb *= SubTextureColor.rgb;
#endif // SUBTEXTUREMODE == 3

#if SUBTEXTUREMODE == 4  // Z~Q( MV1_LAYERBLEND_TYPE_MODULATE2 + 1 )
	TextureDiffuseColor.rgb *= SubTextureColor.rgb * 2.0f;
#endif // SUBTEXTUREMODE == 4

	// Cggꍇ *******************************************************************( Jn )

	// fBt[YJ[ƃXyLJ[̒~ϒl
	TotalDiffuse = cfZeroHalfOneTwo.x ;
#ifdef USE_SPE
	TotalSpecular = cfZeroHalfOneTwo.x ;
#endif // USE_SPE
	
#if TOON
	#if TOON == 1
		TotalLightDiffuse = cfZeroHalfOneTwo.x ;
	#else // TOON == 1
		TotalAmbient = cfZeroHalfOneTwo.x ;
		TotalAngleGen = cfZeroHalfOneTwo.x ;
	#endif
#endif // TOON

	#if	SHADOWMAP
		// _̃eNX`Wl͈͓̏ꍇ̂ݏ
		if( PSInput.ShadowMap1Pos_ShadowMap3PosX.x < -1.0f || PSInput.ShadowMap1Pos_ShadowMap3PosX.x > 1.0f ||
		    PSInput.ShadowMap1Pos_ShadowMap3PosX.y < -1.0f || PSInput.ShadowMap1Pos_ShadowMap3PosX.y > 1.0f ||
		    PSInput.ShadowMap1Pos_ShadowMap3PosX.z <  0.0f || PSInput.ShadowMap1Pos_ShadowMap3PosX.z > 1.0f )
		{
			ShadowRate.x = 1.0f;
		}
		else
		{
			// [xeNX`̍WZo
			// PSInput.ShadowMap1Pos_ShadowMap3PosX.xy  -1.0f ` 1.0f ̒lȂ̂ŁA 0.0f ` 1.0f ̒lɂ
			DepthTexCoord.x = ( PSInput.ShadowMap1Pos_ShadowMap3PosX.x + 1.0f ) / 2.0f;

			// y͍Xɏ㉺]
			DepthTexCoord.y = 1.0f - ( PSInput.ShadowMap1Pos_ShadowMap3PosX.y + 1.0f ) / 2.0f;

			// [xobt@eNX`[x擾
			TextureDepth = tex2D( ShadowMap1Texture, DepthTexCoord );

			// eNX`ɋL^Ă[x( +␳l )yl傫牜ɂƂƂŌőɂ
			ShadowRate.x = smoothstep( PSInput.ShadowMap1Pos_ShadowMap3PosX.z - cfShadowMap1_DAdj_Grad_Enbl0_1.y, PSInput.ShadowMap1Pos_ShadowMap3PosX.z, TextureDepth.r + cfShadowMap1_DAdj_Grad_Enbl0_1.x ) ;
		}

		// _̃eNX`Wl͈͓̏ꍇ̂ݏ
		if( PSInput.ShadowMap2Pos_ShadowMap3PosY.x < -1.0f || PSInput.ShadowMap2Pos_ShadowMap3PosY.x > 1.0f ||
		    PSInput.ShadowMap2Pos_ShadowMap3PosY.y < -1.0f || PSInput.ShadowMap2Pos_ShadowMap3PosY.y > 1.0f ||
		    PSInput.ShadowMap2Pos_ShadowMap3PosY.z <  0.0f || PSInput.ShadowMap2Pos_ShadowMap3PosY.z > 1.0f )
		{
			ShadowRate.y = 1.0f;
		}
		else
		{
			// [xeNX`̍WZo
			// PSInput.ShadowMap2Pos_ShadowMap3PosX.xy  -1.0f ` 1.0f ̒lȂ̂ŁA 0.0f ` 1.0f ̒lɂ
			DepthTexCoord.x = ( PSInput.ShadowMap2Pos_ShadowMap3PosY.x + 1.0f ) / 2.0f;

			// y͍Xɏ㉺]
			DepthTexCoord.y = 1.0f - ( PSInput.ShadowMap2Pos_ShadowMap3PosY.y + 1.0f ) / 2.0f;

			// [xobt@eNX`[x擾
			TextureDepth = tex2D( ShadowMap2Texture, DepthTexCoord );

			// eNX`ɋL^Ă[x( +␳l )yl傫牜ɂƂƂŌőɂ
			ShadowRate.y = smoothstep( PSInput.ShadowMap2Pos_ShadowMap3PosY.z - cfShadowMap1_Enb2_ShadowMap2_DAdj_Grad_Enbl0.z, PSInput.ShadowMap2Pos_ShadowMap3PosY.z, TextureDepth.r + cfShadowMap1_Enb2_ShadowMap2_DAdj_Grad_Enbl0.y ) ;
		}

		// _̃eNX`Wl͈͓̏ꍇ̂ݏ
		if( PSInput.ShadowMap1Pos_ShadowMap3PosX.w < -1.0f || PSInput.ShadowMap1Pos_ShadowMap3PosX.w > 1.0f ||
		    PSInput.ShadowMap2Pos_ShadowMap3PosY.w < -1.0f || PSInput.ShadowMap2Pos_ShadowMap3PosY.w > 1.0f ||
		    PSInput.Fog_ShadowMap3PosZ.y           <  0.0f || PSInput.Fog_ShadowMap3PosZ.y           > 1.0f )
		{
			ShadowRate.z = 1.0f;
		}
		else
		{
			// [xeNX`̍WZo
			// PSInput.ShadowMap1Pos_ShadowMap3PosX.w  PSInput.ShadowMap2Pos_ShadowMap3PosY.w  -1.0f ` 1.0f ̒lȂ̂ŁA 0.0f ` 1.0f ̒lɂ
			DepthTexCoord.x = ( PSInput.ShadowMap1Pos_ShadowMap3PosX.w + 1.0f ) / 2.0f;

			// y͍Xɏ㉺]
			DepthTexCoord.y = 1.0f - ( PSInput.ShadowMap2Pos_ShadowMap3PosY.w + 1.0f ) / 2.0f;

			// [xobt@eNX`[x擾
			TextureDepth = tex2D( ShadowMap3Texture, DepthTexCoord );

			// eNX`ɋL^Ă[x( +␳l )yl傫牜ɂƂƂŌőɂ
			ShadowRate.z = smoothstep( PSInput.Fog_ShadowMap3PosZ.y - cfShadowMap2_Enbl1_2_ShadowMap3_DAdj_Grad.w, PSInput.Fog_ShadowMap3PosZ.y, TextureDepth.r + cfShadowMap2_Enbl1_2_ShadowMap3_DAdj_Grad.z ) ;
		}
	#else // SHADOWMAP
		ShadowRate.x = 1.0f ;
		ShadowRate.y = 1.0f ;
		ShadowRate.z = 1.0f ;
	#endif // SHADOWMAP


	
// Cg0̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG0_USE

	#if LG0_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 0 ].Direction ;

	#else  // LG0_DIR

		// CgxNǧvZ
		lLightDir = normalize( PSInput.VPosition.xyz - cfLight[ 0 ].Position.xyz ) ;

	#endif  // LG0_DIR
	

	
	// EX|bgCglvZ =======================================( Jn )
	#if LG0_SPOT || LG0_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂
		lLightTemp = PSInput.VPosition.xyz - cfLight[ 0 ].Position.xyz ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = cfZeroHalfOneTwo.z / ( cfLight[ 0 ].Range_FallOff_AT0_AT1.z + cfLight[ 0 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 0 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// --------------------------------


		// X|bgCgvZ --------
		#if LG0_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 0 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 0 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 0 ].AT2_SpotP0_SpotP1.z ), cfLight[ 0 ].Range_FallOff_AT0_AT1.y ) ) ;

		#endif // LG0_SPOT
		// --------------------------------


		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 0 ].Range_FallOff_AT0_AT1.x ) ;

	#else // LG0_SPOT || LG0_POINT
	
		lLightGen = 1.0f ;
		
	#endif // LG0_SPOT || LG0_POINT
	
	// EX|bgCglvZ =======================================( I )

	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, SHADOWMAP1_ENABLE_LGT0 ) *
	            max( ShadowRate.y, SHADOWMAP2_ENABLE_LGT0 ) *
	            max( ShadowRate.z, SHADOWMAP3_ENABLE_LGT0 ) ;


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;
	
	#if TOON
		#if TOON == 1
			// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TempF4 = cfLight[ 0 ].Diffuse * DiffuseAngleGen ;
			TotalLightDiffuse += TempF4 * lLightGen * ShadowGen ;
			TotalDiffuse += ( TempF4 + cfLight[ 0 ].Ambient ) * lLightGen ;

		#else // TOON == 1
			// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[
			// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
			// Cg̊px̒~ϒl += Cg̊px
			TotalDiffuse += cfLight[ 0 ].Diffuse ;

			TotalAmbient += cfLight[ 0 ].Ambient.rgb ;
			TotalAngleGen += DiffuseAngleGen * ShadowGen * lLightGen ;

		#endif // TOON == 1
	#else // TOON
	
		// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
		TotalDiffuse += ( cfLight[ 0 ].Diffuse * PSInput.Diffuse * DiffuseAngleGen * ShadowGen + cfLight[ 0 ].Ambient ) * lLightGen ;

	#endif // TOON




	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = normalize( V_to_Eye - lLightDir ) ;
		
		// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
		Temp = pow( max( cfZeroHalfOneTwo.x, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

		// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
		TotalSpecular += Temp * lLightGen * cfLight[ 0 ].Specular * ShadowGen ;

	#endif // USE_SPE


#endif // LG0_USE
// Cg0̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )









	
// Cg1̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG1_USE

	#if LG1_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 1 ].Direction ;

	#else  // LG1_DIR

		// CgxNǧvZ
		lLightDir = normalize( PSInput.VPosition.xyz - cfLight[ 1 ].Position.xyz ) ;

	#endif  // LG1_DIR
	

	
	// EX|bgCglvZ =======================================( Jn )
	#if LG1_SPOT || LG1_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂
		lLightTemp = PSInput.VPosition.xyz - cfLight[ 1 ].Position.xyz ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = cfZeroHalfOneTwo.z / ( cfLight[ 1 ].Range_FallOff_AT0_AT1.z + cfLight[ 1 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 1 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// --------------------------------


		// X|bgCgvZ --------
		#if LG1_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 1 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 1 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 1 ].AT2_SpotP0_SpotP1.z ), cfLight[ 1 ].Range_FallOff_AT0_AT1.y ) ) ;

		#endif // LG1_SPOT
		// --------------------------------


		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 1 ].Range_FallOff_AT0_AT1.x ) ;

	#else // LG1_SPOT || LG1_POINT
	
		lLightGen = 1.0f ;
		
	#endif // LG1_SPOT || LG1_POINT
	
	// EX|bgCglvZ =======================================( I )

	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, SHADOWMAP1_ENABLE_LGT1 ) *
	            max( ShadowRate.y, SHADOWMAP2_ENABLE_LGT1 ) *
	            max( ShadowRate.z, SHADOWMAP3_ENABLE_LGT1 ) ;


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;
	
	#if TOON
		#if TOON == 1
			// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TempF4 = cfLight[ 1 ].Diffuse * DiffuseAngleGen ;
			TotalLightDiffuse += TempF4 * lLightGen * ShadowGen ;
			TotalDiffuse += ( TempF4 + cfLight[ 1 ].Ambient ) * lLightGen ;

		#else // TOON == 1
			// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[
			// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
			// Cg̊px̒~ϒl += Cg̊px
			TotalDiffuse += cfLight[ 1 ].Diffuse ;

			TotalAmbient += cfLight[ 1 ].Ambient.rgb ;
			TotalAngleGen += DiffuseAngleGen * ShadowGen * lLightGen ;

		#endif // TOON == 1
	#else // TOON
	
		// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
		TotalDiffuse += ( cfLight[ 1 ].Diffuse * PSInput.Diffuse * DiffuseAngleGen * ShadowGen + cfLight[ 1 ].Ambient ) * lLightGen ;

	#endif // TOON




	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = normalize( V_to_Eye - lLightDir ) ;
		
		// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
		Temp = pow( max( cfZeroHalfOneTwo.x, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

		// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
		TotalSpecular += Temp * lLightGen * cfLight[ 1 ].Specular * ShadowGen ;

	#endif // USE_SPE


#endif // LG1_USE
// Cg1̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )









	
// Cg2̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG2_USE

	#if LG2_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 2 ].Direction ;

	#else  // LG2_DIR

		// CgxNǧvZ
		lLightDir = normalize( PSInput.VPosition.xyz - cfLight[ 2 ].Position.xyz ) ;

	#endif  // LG2_DIR
	

	
	// EX|bgCglvZ =======================================( Jn )
	#if LG2_SPOT || LG2_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂
		lLightTemp = PSInput.VPosition.xyz - cfLight[ 2 ].Position.xyz ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = cfZeroHalfOneTwo.z / ( cfLight[ 2 ].Range_FallOff_AT0_AT1.z + cfLight[ 2 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 2 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// --------------------------------


		// X|bgCgvZ --------
		#if LG2_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 2 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 2 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 2 ].AT2_SpotP0_SpotP1.z ), cfLight[ 2 ].Range_FallOff_AT0_AT1.y ) ) ;

		#endif // LG2_SPOT
		// --------------------------------


		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 2 ].Range_FallOff_AT0_AT1.x ) ;

	#else // LG2_SPOT || LG2_POINT
	
		lLightGen = 1.0f ;
		
	#endif // LG2_SPOT || LG2_POINT
	
	// EX|bgCglvZ =======================================( I )

	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, SHADOWMAP1_ENABLE_LGT2 ) *
	            max( ShadowRate.y, SHADOWMAP2_ENABLE_LGT2 ) *
	            max( ShadowRate.z, SHADOWMAP3_ENABLE_LGT2 ) ;


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;
	
	#if TOON
		#if TOON == 1
			// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TempF4 = cfLight[ 2 ].Diffuse * DiffuseAngleGen ;
			TotalLightDiffuse += TempF4 * lLightGen * ShadowGen ;
			TotalDiffuse += ( TempF4 + cfLight[ 2 ].Ambient ) * lLightGen ;

		#else // TOON == 1
			// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[
			// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
			// Cg̊px̒~ϒl += Cg̊px
			TotalDiffuse += cfLight[ 2 ].Diffuse ;

			TotalAmbient += cfLight[ 2 ].Ambient.rgb ;
			TotalAngleGen += DiffuseAngleGen * ShadowGen * lLightGen ;

		#endif // TOON == 1
	#else // TOON
	
		// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
		TotalDiffuse += ( cfLight[ 2 ].Diffuse * PSInput.Diffuse * DiffuseAngleGen * ShadowGen + cfLight[ 2 ].Ambient ) * lLightGen ;

	#endif // TOON




	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = normalize( V_to_Eye - lLightDir ) ;
		
		// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
		Temp = pow( max( cfZeroHalfOneTwo.x, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

		// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
		TotalSpecular += Temp * lLightGen * cfLight[ 2 ].Specular * ShadowGen ;

	#endif // USE_SPE


#endif // LG2_USE
// Cg2̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )









	
// Cg3̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG3_USE

	#if LG3_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 3 ].Direction ;

	#else  // LG3_DIR

		// CgxNǧvZ
		lLightDir = normalize( PSInput.VPosition.xyz - cfLight[ 3 ].Position.xyz ) ;

	#endif  // LG3_DIR
	

	
	// EX|bgCglvZ =======================================( Jn )
	#if LG3_SPOT || LG3_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂
		lLightTemp = PSInput.VPosition.xyz - cfLight[ 3 ].Position.xyz ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = cfZeroHalfOneTwo.z / ( cfLight[ 3 ].Range_FallOff_AT0_AT1.z + cfLight[ 3 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 3 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// --------------------------------


		// X|bgCgvZ --------
		#if LG3_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 3 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 3 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 3 ].AT2_SpotP0_SpotP1.z ), cfLight[ 3 ].Range_FallOff_AT0_AT1.y ) ) ;

		#endif // LG3_SPOT
		// --------------------------------


		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 3 ].Range_FallOff_AT0_AT1.x ) ;

	#else // LG3_SPOT || LG3_POINT
	
		lLightGen = 1.0f ;
		
	#endif // LG3_SPOT || LG3_POINT
	
	// EX|bgCglvZ =======================================( I )

	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, SHADOWMAP1_ENABLE_LGT3 ) *
	            max( ShadowRate.y, SHADOWMAP2_ENABLE_LGT3 ) *
	            max( ShadowRate.z, SHADOWMAP3_ENABLE_LGT3 ) ;


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;
	
	#if TOON
		#if TOON == 1
			// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TempF4 = cfLight[ 3 ].Diffuse * DiffuseAngleGen ;
			TotalLightDiffuse += TempF4 * lLightGen * ShadowGen ;
			TotalDiffuse += ( TempF4 + cfLight[ 3 ].Ambient ) * lLightGen ;

		#else // TOON == 1
			// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[
			// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
			// Cg̊px̒~ϒl += Cg̊px
			TotalDiffuse += cfLight[ 3 ].Diffuse ;

			TotalAmbient += cfLight[ 3 ].Ambient.rgb ;
			TotalAngleGen += DiffuseAngleGen * ShadowGen * lLightGen ;

		#endif // TOON == 1
	#else // TOON
	
		// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
		TotalDiffuse += ( cfLight[ 3 ].Diffuse * PSInput.Diffuse * DiffuseAngleGen * ShadowGen + cfLight[ 3 ].Ambient ) * lLightGen ;

	#endif // TOON




	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = normalize( V_to_Eye - lLightDir ) ;
		
		// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
		Temp = pow( max( cfZeroHalfOneTwo.x, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

		// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
		TotalSpecular += Temp * lLightGen * cfLight[ 3 ].Specular * ShadowGen ;

	#endif // USE_SPE


#endif // LG3_USE
// Cg3̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )









	
// Cg4̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG4_USE

	#if LG4_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 4 ].Direction ;

	#else  // LG4_DIR

		// CgxNǧvZ
		lLightDir = normalize( PSInput.VPosition.xyz - cfLight[ 4 ].Position.xyz ) ;

	#endif  // LG4_DIR
	

	
	// EX|bgCglvZ =======================================( Jn )
	#if LG4_SPOT || LG4_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂
		lLightTemp = PSInput.VPosition.xyz - cfLight[ 4 ].Position.xyz ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = cfZeroHalfOneTwo.z / ( cfLight[ 4 ].Range_FallOff_AT0_AT1.z + cfLight[ 4 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 4 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// --------------------------------


		// X|bgCgvZ --------
		#if LG4_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 4 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 4 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 4 ].AT2_SpotP0_SpotP1.z ), cfLight[ 4 ].Range_FallOff_AT0_AT1.y ) ) ;

		#endif // LG4_SPOT
		// --------------------------------


		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 4 ].Range_FallOff_AT0_AT1.x ) ;

	#else // LG4_SPOT || LG4_POINT
	
		lLightGen = 1.0f ;
		
	#endif // LG4_SPOT || LG4_POINT
	
	// EX|bgCglvZ =======================================( I )

	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, SHADOWMAP1_ENABLE_LGT4 ) *
	            max( ShadowRate.y, SHADOWMAP2_ENABLE_LGT4 ) *
	            max( ShadowRate.z, SHADOWMAP3_ENABLE_LGT4 ) ;


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;
	
	#if TOON
		#if TOON == 1
			// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TempF4 = cfLight[ 4 ].Diffuse * DiffuseAngleGen ;
			TotalLightDiffuse += TempF4 * lLightGen * ShadowGen ;
			TotalDiffuse += ( TempF4 + cfLight[ 4 ].Ambient ) * lLightGen ;

		#else // TOON == 1
			// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[
			// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
			// Cg̊px̒~ϒl += Cg̊px
			TotalDiffuse += cfLight[ 4 ].Diffuse ;

			TotalAmbient += cfLight[ 4 ].Ambient.rgb ;
			TotalAngleGen += DiffuseAngleGen * ShadowGen * lLightGen ;

		#endif // TOON == 1
	#else // TOON
	
		// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
		TotalDiffuse += ( cfLight[ 4 ].Diffuse * PSInput.Diffuse * DiffuseAngleGen * ShadowGen + cfLight[ 4 ].Ambient ) * lLightGen ;

	#endif // TOON




	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = normalize( V_to_Eye - lLightDir ) ;
		
		// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
		Temp = pow( max( cfZeroHalfOneTwo.x, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

		// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
		TotalSpecular += Temp * lLightGen * cfLight[ 4 ].Specular * ShadowGen ;

	#endif // USE_SPE


#endif // LG4_USE
// Cg4̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )









	
// Cg5̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
#if LG5_USE

	#if LG5_DIR

		// Cg̕vZ
		lLightDir = cfLight[ 5 ].Direction ;

	#else  // LG5_DIR

		// CgxNǧvZ
		lLightDir = normalize( PSInput.VPosition.xyz - cfLight[ 5 ].Position.xyz ) ;

	#endif  // LG5_DIR
	

	
	// EX|bgCglvZ =======================================( Jn )
	#if LG5_SPOT || LG5_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂
		lLightTemp = PSInput.VPosition.xyz - cfLight[ 5 ].Position.xyz ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = cfZeroHalfOneTwo.z / ( cfLight[ 5 ].Range_FallOff_AT0_AT1.z + cfLight[ 5 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 5 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

		// --------------------------------


		// X|bgCgvZ --------
		#if LG5_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, cfLight[ 5 ].Direction ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 5 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 5 ].AT2_SpotP0_SpotP1.z ), cfLight[ 5 ].Range_FallOff_AT0_AT1.y ) ) ;

		#endif // LG5_SPOT
		// --------------------------------


		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, cfLight[ 5 ].Range_FallOff_AT0_AT1.x ) ;

	#else // LG5_SPOT || LG5_POINT
	
		lLightGen = 1.0f ;
		
	#endif // LG5_SPOT || LG5_POINT
	
	// EX|bgCglvZ =======================================( I )

	
	// eɂ錸Zo
	ShadowGen = max( ShadowRate.x, SHADOWMAP1_ENABLE_LGT5 ) *
	            max( ShadowRate.y, SHADOWMAP2_ENABLE_LGT5 ) *
	            max( ShadowRate.z, SHADOWMAP3_ENABLE_LGT5 ) ;


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;
	
	#if TOON
		#if TOON == 1
			// gD[̏ꍇ͂̎_ł͒_or}eÃfBt[YJ[͎gpȂ
			// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
			TempF4 = cfLight[ 5 ].Diffuse * DiffuseAngleGen ;
			TotalLightDiffuse += TempF4 * lLightGen * ShadowGen ;
			TotalDiffuse += ( TempF4 + cfLight[ 5 ].Ambient ) * lLightGen ;

		#else // TOON == 1
			// gD[Q̏ꍇ̓fBt[YJ[ƃCg̊px͕ʁXɕۑĂ
			// fBt[YJ[~ϒl += Cg̃fBt[YJ[
			// Cg̃ArGgJ[̒~ϒl += Cg̃ArGgJ[
			// Cg̊px̒~ϒl += Cg̊px
			TotalDiffuse += cfLight[ 5 ].Diffuse ;

			TotalAmbient += cfLight[ 5 ].Ambient.rgb ;
			TotalAngleGen += DiffuseAngleGen * ShadowGen * lLightGen ;

		#endif // TOON == 1
	#else // TOON
	
		// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * fBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
		TotalDiffuse += ( cfLight[ 5 ].Diffuse * PSInput.Diffuse * DiffuseAngleGen * ShadowGen + cfLight[ 5 ].Ambient ) * lLightGen ;

	#endif // TOON




	// XyLJ[vZ
	#ifdef USE_SPE

		// n[txNǧvZ
		TempF3 = normalize( V_to_Eye - lLightDir ) ;
		
		// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
		Temp = pow( max( cfZeroHalfOneTwo.x, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

		// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
		TotalSpecular += Temp * lLightGen * cfLight[ 5 ].Specular * ShadowGen ;

	#endif // USE_SPE


#endif // LG5_USE
// Cg5̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )















	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	#if TOON != 2
		// TotalDiffuse = CgfBt[YJ[~ϒl + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
		TotalDiffuse += cfAmbient_Emissive ;
	#else // TOON != 2
		// ArGgJ[̒~ϒl += }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z
		TotalAmbient += cfAmbient_Emissive.rgb ;
	#endif  // TOON != 2

	#ifdef USE_SPE
		#if TOON
			#if TOON == 1
				// gD[P̎̏o͌vZ
				ToonSpecularGradColor = tex2D( ToonSpecularGradTexture, max( TotalSpecular.b, max( TotalSpecular.r, TotalSpecular.g ) ) ) ;
				
				#ifdef USE_SPETEX
					TextureSpecularColor.rgb *= ToonSpecularGradColor.rgb ;
				#else  // USE_SPETEX
					TextureSpecularColor = ToonSpecularGradColor ;
				#endif // USE_SPETEX
				
				TextureSpecularColor.rgb *= tex3D( ToonRGBtoVMaxRGBVolumeTexture, TotalSpecular.rgb ).rgb * PSInput.Specular.rgb ;

				TextureDiffuseColor.rgb *= tex3D( ToonRGBtoVMaxRGBVolumeTexture, TotalLightDiffuse.rgb ).rgb * PSInput.Diffuse.rgb ;

				ToonDiffuseGradColor = tex2D( ToonDiffuseGradTexture, max( TotalDiffuse.b, max( TotalDiffuse.r, TotalDiffuse.g ) ) ) ;

				#if TOON_DIFOP_MUL
					PSOutput.Color0 = TextureDiffuseColor * ToonDiffuseGradColor ;
				#endif // TOON_DIFOP_MUL
				#if TOON_DIFOP_TRANS
					PSOutput.Color0 = lerp( TextureDiffuseColor, ToonDiffuseGradColor, ToonDiffuseGradColor.a ) ;
				#endif // TOON_DIFOP_TRANS

				#if TOON_SPEOP_ADD
					PSOutput.Color0 = PSOutput.Color0 + TextureSpecularColor ;
				#endif // TOON_SPEOP_ADD
				#if TOON_SPEOP_TRANS
					PSOutput.Color0 = lerp( PSOutput.Color0, TextureSpecularColor, TextureSpecularColor.a ) ;
				#endif // TOON_SPEOP_TRANS

				PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a ;

				#if TOON_DIFOP_MUL
					PSOutput.Color0.a *= ToonDiffuseGradColor.a ;
				#endif // TOON_DIFOP_MUL
				
			#else  // TOON == 1
				// gD[Q̎̏o͌vZ
				ToonDiffuseGradColor = tex2D( ToonDiffuseGradTexture, TotalAngleGen ) ;

				// o = saturate( saturate( ArGgJ[̒~ϒl + }eÃfBt[YJ[ * Cg̃fBt[YJ[̒~ϒl ) * eNX`Of[VJ[ + XyLJ[~ϒl * }eÃXyLJ[ ) * eNX`J[
				PSOutput.Color0.rgb = saturate( saturate( TotalDiffuse.rgb * PSInput.Diffuse.rgb + TotalAmbient ) * ToonDiffuseGradColor.rgb + PSInput.Specular.rgb * TotalSpecular.rgb ) * TextureDiffuseColor.rgb ;
				
				#if TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD
					// XtBA}bv̐F擾
					TempF3 = Normal * float3( 0.5f, -0.5f, 0.0f ) + cfZeroHalfOneTwo.yyy ;
					ToonSphereMapColor = tex2D( ToonSphereMapTexture, TempF3.xy ) ;
					
					#if TOON_SPHEREOP_MUL
						// XtBA}bv̐Fo͂ɏZ
						PSOutput.Color0.rgb *= ToonSphereMapColor.rgb ;
					#endif // TOON_SPHEREOP_MUL
					
					#if TOON_SPHEREOP_ADD
						// XtBA}bv̐Fo͂ɉZ
						PSOutput.Color0.rgb += ToonSphereMapColor.rgb ;
					#endif // TOON_SPHEREOP_ADD
					
				#endif // TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD

				#if TOON_SPHEREOP_MUL

					// o̓At@ = eNX`At@ * FactorAt@ * _At@ * XtBA}bvAt@
					PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a * ToonSphereMapColor.a ;

				#else // TOON_SPHEREOP_MUL

					// o̓At@ = eNX`At@ * FactorAt@ * _At@
					PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a ;

				#endif // TOON_SPHEREOP_MUL

			#endif   // TOON == 1
		#else  // TOON

			#ifdef USE_SPETEX
				// TextureSpecularColor = Cg̃XyLJ[~ϒl * XyLJ[ * XyLeNX`J[
				TextureSpecularColor = tex2D( SpecularMapTexture, PSInput.TexCoords0_1.xy ) * TotalSpecular * PSInput.Specular ;
			#else  // USE_SPETEX
				// TextureSpecularColor = Cg̃XyLJ[~ϒl * XyLJ[
				TextureSpecularColor = TotalSpecular * PSInput.Specular ;
			#endif // USE_SPETEX

			// o̓J[ = TotalDiffuse * eNX`J[ + TextureSpecularColor

			PSOutput.Color0.rgb = TextureDiffuseColor.rgb * TotalDiffuse.rgb + TextureSpecularColor.rgb ;
			PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a ;

		#endif // TOON

	#else  // USE_SPE

		#if TOON
			#if TOON == 1
				ToonDiffuseGradColor = tex2D( ToonDiffuseGradTexture, max( TotalDiffuse.b, max( TotalDiffuse.r, TotalDiffuse.g ) ) ) ;
				TextureDiffuseColor.rgb *= tex3D( ToonRGBtoVMaxRGBVolumeTexture, TotalLightDiffuse.rgb ).rgb * PSInput.Diffuse.rgb ;

				#if TOON_DIFOP_MUL
					// o̓J[ = eNX`J[ * fBt[YJ[~ϒl * Of[VJ[
					PSOutput.Color0 = TextureDiffuseColor * ToonDiffuseGradColor ;
				#endif // TOON_DIFOP_MUL
				#if TOON_DIFOP_TRANS
					// o̓J[ = Of[VJ[ * Of[V + ( 1 - Of[V ) * ( eNX`J[ * fBt[YJ[~ϒl )
					PSOutput.Color0 = lerp( TextureDiffuseColor, ToonDiffuseGradColor, ToonDiffuseGradColor.a ) ;
				#endif // TOON_DIFOP_TRANS

				// o̓ = eNX` * fBt[Y * 惿
				PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a ;

				// Z̏ꍇ̓lOf[VƏZ
				#if TOON_DIFOP_MUL
					PSOutput.Color0.a *= ToonDiffuseGradColor.a ;
				#endif // TOON_DIFOP_MUL

			#else	// TOON == 1
				// gD[Q̎̏o͌vZ
				ToonDiffuseGradColor = tex2D( ToonDiffuseGradTexture, TotalAngleGen ) ;

				// o = ( ArGgJ[̒~ϒl + }eÃfBt[YJ[ * Cg̃fBt[YJ[̒~ϒl ) * eNX`Of[VJ[ * eNX`J[
				PSOutput.Color0.rgb = saturate( TotalDiffuse.rgb * PSInput.Diffuse.rgb + TotalAmbient.rgb ) * ToonDiffuseGradColor.rgb * TextureDiffuseColor.rgb ;

				#if TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD
					// XtBA}bv̐F擾
					TempF3 = Normal * float3( 0.5f, -0.5f, 0.0f ) + cfZeroHalfOneTwo.yyy ;
					ToonSphereMapColor = tex2D( ToonSphereMapTexture, TempF3.xy ) ;
					
					#if TOON_SPHEREOP_MUL
						// XtBA}bv̐Fo͂ɏZ
						PSOutput.Color0.rgb *= ToonSphereMapColor.rgb ;
					#endif // TOON_SPHEREOP_MUL
					
					#if TOON_SPHEREOP_ADD
						// XtBA}bv̐Fo͂ɉZ
						PSOutput.Color0.rgb += ToonSphereMapColor.rgb ;
					#endif // TOON_SPHEREOP_ADD
					
				#endif // TOON_SPHEREOP_MUL || TOON_SPHEREOP_ADD

				#if TOON_SPHEREOP_MUL

					PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a * ToonSphereMapColor.a ;

				#else // TOON_SPHEREOP_MUL

					PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a ;

				#endif // TOON_SPHEREOP_MUL

			#endif		// TOON == 1
		#else  // TOON
			// o̓J[ = TotalDiffuse * eNX`J[
			PSOutput.Color0.rgb = TotalDiffuse.rgb * TextureDiffuseColor.rgb ;

			// o̓ = eNX` * fBt[Y * 惿
			PSOutput.Color0.a = TextureDiffuseColor.a * cfFactorColor.a * PSInput.Diffuse.a ;
		#endif // TOON

	#endif // USE_SPE

	// tHO
	PSOutput.Color0.rgb = lerp( cfFogColor.rgb, PSOutput.Color0.rgb, saturate( PSInput.Fog_ShadowMap3PosZ.x ) );

	// At@ZJ[
	if( cfMulAlphaColor.x > 0.5f )
	{
		PSOutput.Color0.rgb *= PSOutput.Color0.a;
	}

	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// Cggꍇ *******************************************************************( I )

	return PSOutput ;
}

